Subject: Re: [PATCH v5 05/10] drm/bridge: dw-hdmi-qp: Add HDMI 2.0 SCDC scrambling and high TMDS clock ratio support

From: Heiko Stuebner <[email-masked]>
Date: Mon, 27 Apr 2026 21:09:09 +0200

Am Montag, 27. April 2026, 18:39:44 Mitteleuropäische Sommerzeit schrieb Cristian Ciocaltea:
> Hello Heiko,
> 
> Thanks for the quick reviews!
> 
> On 4/27/26 1:49 PM, Heiko Stuebner wrote:
> > Am Sonntag, 26. April 2026, 02:20:17 Mitteleuropäische Sommerzeit schrieb Cristian Ciocaltea:
> >> Enable HDMI 2.0 display modes (e.g. 4K@60Hz) by adding SCDC management
> >> for the high TMDS clock ratio and scrambling, required when the TMDS
> >> character rate exceeds the 340 MHz HDMI 1.4b limit.
> >>
> >> A periodic work item monitors the sink's scrambling status to recover
> >> from sink-side resets.  On hotplug detect, if SCDC scrambling state is
> >> out of sync with the driver, trigger a CRTC reset to re-establish the
> >> link.
> >>
> >> Reject modes requiring TMDS rates above 600 MHz, as those fall in the
> >> HDMI 2.1 FRL domain which is not supported. In no_hpd configurations,
> >> further restrict to 340 MHz since SCDC requires a connected sink.
> >>
> >> Tested-by: Diederik de Haas <[email-masked]>
> >> Tested-by: Maud Spierings <[email-masked]>
> >> Signed-off-by: Cristian Ciocaltea <[email-masked]>
> >> ---
> >>  drivers/gpu/drm/bridge/synopsys/dw-hdmi-qp.c | 188 ++++++++++++++++++++++++---
> >>  1 file changed, 172 insertions(+), 16 deletions(-)
> >>
> >> diff --git a/drivers/gpu/drm/bridge/synopsys/dw-hdmi-qp.c b/drivers/gpu/drm/bridge/synopsys/dw-hdmi-qp.c
> >> index d649a1cf07f5..c482a8e7da25 100644
> >> --- a/drivers/gpu/drm/bridge/synopsys/dw-hdmi-qp.c
> >> +++ b/drivers/gpu/drm/bridge/synopsys/dw-hdmi-qp.c
> >> @@ -2,6 +2,7 @@
> >>  /*
> >>   * Copyright (c) 2021-2022 Rockchip Electronics Co., Ltd.
> >>   * Copyright (c) 2024 Collabora Ltd.
> >> + * Copyright (c) 2025 Amazon.com, Inc. or its affiliates.
> > 
> > I have no real clue about the inner workings of hdmi, but that line
> > does make me curious, because no part of the patch authorship does
> > mention Amazon ;-) .
> 
> That was intentional: although the code was written by Collabora, the copyright
> belongs to Amazon.

They selected a nice chip then :-D

> > Also I think "or it's affiliates" might be way too broad, because this
> > can be essentially everyone. So noone in the future will know who to
> > ask on copyright questions.
> > 
> > Similarly when _somebody_ comes forward with "I hold a copyright on this"
> > no-one could verify this claim as well.
> > 
> > I somehow expect _one_ entity being specified, not possibly hundreds.
> 
> Hmm, I followed the wording already used elsewhere in the kernel tree:
> 
> $ git grep 'Copyright.*Amazon.*affiliates' | wc -l
> 93
> 
> There appears to be only a single instance that omits “affiliates”:
> 
> $ git grep 'Copyright.*Amazon' | grep -v affiliates
> drivers/power/supply/max14656_charger_detector.c: * Copyright (C) Amazon Technologies Inc. All rights reserved.
> 
> Which was added nearly ten years ago, so I’m not sure it makes sense to adopt
> that form now.
> 
> Actually, this seems to be fairly common among other vendors as well:
> 
> $ git grep 'Copyright.*affiliates' | wc -l
> 1014

okay then ... if that is already used a lot, and nobody else complained
then it should be fine I guess :-) .

It just sounded strange to me when reading that earlier.

Thanks a lot for digging those stats up
Heiko